From 87bde445b26043718f90ecc22c611d0e6e88aaf9 Mon Sep 17 00:00:00 2001
From: Maxim Cournoyer <maxim.cournoyer@gmail.com>
Date: Wed, 14 Jun 2023 21:20:00 -0400
Subject: [PATCH 5/6] fixups for autoupdate bug

sed 's/_au_m4_changequote(\[,\])//g' -i configure.in
---
 configure.in | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

diff --git a/configure.in b/configure.in
index 4255910bfe..bdb533946e 100644
--- a/configure.in
+++ b/configure.in
@@ -1410,7 +1410,7 @@ case "${host}" in
     AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include <CoreFoundation/CFBase.h>
 ]], [[]])],[AC_MSG_RESULT([yes])],[AC_MSG_RESULT([no])
         AC_MSG_CHECKING([if __CF_USE_FRAMEWORK_INCLUDES__ is required])
-        _au_m4_changequote([,])AC_TRY_COMPILE([#define __CF_USE_FRAMEWORK_INCLUDES__
+        AC_TRY_COMPILE([#define __CF_USE_FRAMEWORK_INCLUDES__
 #include <CoreFoundation/CFBase.h>
         ],[],
         [AC_MSG_RESULT([yes])
@@ -3426,7 +3426,7 @@ if test "$wxUSE_SHARED" = "yes"; then
                 AC_MSG_RESULT([no])
                 AC_MSG_CHECKING([if the linker accepts -R])
                 LDFLAGS="$saveLdflags -Wl,-R,/"
-                _au_m4_changequote([,])AC_TRY_LINK(
+                AC_TRY_LINK(
                     [],[],
                     [
                         AC_MSG_RESULT([yes])
@@ -3917,7 +3917,7 @@ if test "$wx_cv_func_statvfs" = "yes"; then
                 l += fs.f_blocks;
                 l += fs.f_bavail;
             ]])],[wx_cv_type_statvfs_t=statvfs_t],[
-                _au_m4_changequote([,])AC_TRY_COMPILE(
+                AC_TRY_COMPILE(
                     [
                         #include <sys/statvfs.h>
                     ],
@@ -5003,7 +5003,7 @@ if test "$USE_UNIX" = 1 ; then
             ]])],[ac_cv_header_sys_soundcard=yes],[
                 saveLibs="$LIBS"
                 LIBS="$saveLibs -lossaudio"
-                _au_m4_changequote([,])AC_TRY_LINK([
+                AC_TRY_LINK([
                         #include <sys/ioctl.h>
                         #include <sys/soundcard.h>
                     ],
@@ -5437,7 +5437,7 @@ if test "$ac_cv_func_gettimeofday" = "yes"; then
             ]], [[
                 struct timeval tv;
                 gettimeofday(&tv, NULL);
-            ]])],[wx_cv_func_gettimeofday_has_2_args=yes],[_au_m4_changequote([,])AC_TRY_COMPILE(
+            ]])],[wx_cv_func_gettimeofday_has_2_args=yes],[AC_TRY_COMPILE(
                  [
                      #include <sys/time.h>
                      #include <unistd.h>
@@ -5475,7 +5475,7 @@ if test "$wxUSE_DATETIME" = "yes"; then
                             ]])],[
                                 wx_cv_var_timezone=timezone
                             ],[
-                                _au_m4_changequote([,])AC_TRY_COMPILE(
+                                AC_TRY_COMPILE(
                                     [
                                         #include <time.h>
                                     ],
@@ -5487,7 +5487,7 @@ if test "$wxUSE_DATETIME" = "yes"; then
                                         wx_cv_var_timezone=_timezone
                                     ],
                                     [
-                                        _au_m4_changequote([,])AC_TRY_COMPILE(
+                                        AC_TRY_COMPILE(
                                             [
                                                 #include <time.h>
                                             ],
@@ -5628,7 +5628,7 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                             CFLAGS="-Werror $CFLAGS"
                         fi
 
-                        _au_m4_changequote([,])AC_TRY_COMPILE(
+                        AC_TRY_COMPILE(
                             [
                                 #include <sys/types.h>
                                 #include <sys/socket.h>
@@ -5638,7 +5638,7 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                                 getsockname(0, 0, &len);
                             ],
                             wx_cv_type_getsockname3=size_t, [
-                            _au_m4_changequote([,])AC_TRY_COMPILE(
+                            AC_TRY_COMPILE(
                                 [
                                     #include <sys/types.h>
                                     #include <sys/socket.h>
@@ -5681,7 +5681,7 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                         socklen_t len;
                         getsockopt(0, 0, 0, 0, &len);
                     ]])],[wx_cv_type_getsockopt5=socklen_t],[
-                        _au_m4_changequote([,])AC_TRY_COMPILE(
+                        AC_TRY_COMPILE(
                             [
                                 #include <sys/types.h>
                                 #include <sys/socket.h>
@@ -5691,7 +5691,7 @@ if test "$wxUSE_SOCKETS" = "yes" ; then
                                 getsockopt(0, 0, 0, 0, &len);
                             ],
                             wx_cv_type_getsockopt5=size_t, [
-                            _au_m4_changequote([,])AC_TRY_COMPILE(
+                            AC_TRY_COMPILE(
                                 [
                                     #include <sys/types.h>
                                     #include <sys/socket.h>
-- 
2.40.1