Index: index.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/index.php,v
retrieving revision 1.1.1.1.2.1
diff -u -r1.1.1.1.2.1 index.php
--- index.php	27 Feb 2004 03:35:02 -0000	1.1.1.1.2.1
+++ index.php	16 Mar 2004 08:59:00 -0000
@@ -211,7 +211,7 @@
 		$login = $GLOBALS['phpgw']->db->db_addslashes($row['account_lid']);
 		$users_opt = 2|4|16|32|64|128|256|512|2048|4096|8192|16384|131072|4194304;
 		if ($row['account_status'] != 'A') {
-			$user_opts |= 2097152;
+			$users_opt |= 2097152;
 		}
 		$GLOBALS['phpgw']->db->query("INSERT INTO phpgw_fud_users (last_visit, join_date, theme, alias, login, email, passwd, name, users_opt, phpgw_id) VALUES(".time().", ".time().", {$theme}, '{$alias}', '{$login}', '{$email}', '{$row['account_pwd']}', '{$name}', {$users_opt}, {$phpgw_id})");
 	}
Index: inc/class.ufud.inc.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/inc/class.ufud.inc.php,v
retrieving revision 1.1.1.1.2.2
diff -u -r1.1.1.1.2.2 class.ufud.inc.php
--- inc/class.ufud.inc.php	9 Mar 2004 14:32:45 -0000	1.1.1.1.2.2
+++ inc/class.ufud.inc.php	16 Mar 2004 08:59:00 -0000
@@ -42,7 +42,7 @@
 				$login = addslashes($row['account_lid']);
 				$users_opt = 2|4|16|32|64|128|256|512|2048|4096|8192|16384|131072|4194304;
 				if ($row['account_status'] != 'A') {
-					$user_opts |= 2097152;
+					$users_opt |= 2097152;
 				}
 			}
 			else
@@ -77,6 +77,9 @@
 			}
 			else
 			{
+			    $lid = 0;
+			    $fname = '';
+			    $lname = '';
 				$GLOBALS['phpgw']->accounts->get_account_name($GLOBALS['hook_values']['account_id'], $lid, $fname,$lname);
 				$name = addslashes($fname.' '.$lname);
 				$email = addslashes($this->__get_email($GLOBALS['hook_values']['account_id']));
@@ -122,7 +125,7 @@
 			// available vars...
 			$lid    = $GLOBALS['hook_values']['account_lid'];
 			$id     = $GLOBALS['hook_values']['account_id'];
-			$passwd = $GLOBALS['hook_values']['new_passwd'];
+			//$passwd = $GLOBALS['hook_values']['new_passwd'];
 			$fname  = $GLOBALS['hook_values']['account_firstname'];
 			$lname  = $GLOBALS['hook_values']['account_lastname'];
 			
Index: inc/hook_admin.inc.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/inc/hook_admin.inc.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 hook_admin.inc.php
--- inc/hook_admin.inc.php	1 Nov 2003 22:57:15 -0000	1.1.1.1
+++ inc/hook_admin.inc.php	16 Mar 2004 08:59:00 -0000
@@ -17,6 +17,6 @@
 		);
 
 //Do not modify below this line
-		display_section($appname,$file);
+		display_section($appname,$file); // $appname possible undefined
 	}
 ?>
Index: inc/hook_preferences.inc.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/inc/hook_preferences.inc.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 hook_preferences.inc.php
--- inc/hook_preferences.inc.php	1 Nov 2003 22:57:15 -0000	1.1.1.1
+++ inc/hook_preferences.inc.php	16 Mar 2004 08:59:00 -0000
@@ -17,6 +17,6 @@
 		);
 
 //Do not modify below this line
-		display_section($appname,$file);
+		display_section($appname,$file); // $appname possible undefined
 	}
 ?>
Index: setup/index.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/index.php,v
retrieving revision 1.1.1.1.2.1
diff -u -r1.1.1.1.2.1 index.php
--- setup/index.php	27 Feb 2004 03:35:02 -0000	1.1.1.1.2.1
+++ setup/index.php	16 Mar 2004 08:59:00 -0000
@@ -211,7 +211,7 @@
 		$login = $GLOBALS['phpgw']->db->db_addslashes($row['account_lid']);
 		$users_opt = 2|4|16|32|64|128|256|512|2048|4096|8192|16384|131072|4194304;
 		if ($row['account_status'] != 'A') {
-			$user_opts |= 2097152;
+			$users_opt |= 2097152;
 		}
 		$GLOBALS['phpgw']->db->query("INSERT INTO phpgw_fud_users (last_visit, join_date, theme, alias, login, email, passwd, name, users_opt, phpgw_id) VALUES(".time().", ".time().", {$theme}, '{$alias}', '{$login}', '{$email}', '{$row['account_pwd']}', '{$name}', {$users_opt}, {$phpgw_id})");
 	}
Index: setup/base/include/compiler.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/compiler.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 compiler.inc
--- setup/base/include/compiler.inc	1 Nov 2003 22:58:44 -0000	1.1.1.1
+++ setup/base/include/compiler.inc	16 Mar 2004 08:59:00 -0000
@@ -132,7 +132,7 @@
 
 	$op = 0;
 	$ret = '';
-	$ch_list =& $GLOBALS['__char_list'];
+	// $ch_list =& $GLOBALS['__char_list'];
 
 	do {
 		@$chr = $str[$p + 1];
@@ -356,7 +356,7 @@
 		}
 	}
 
-	$cmp =& $GLOBALS['__COMPILER__'];
+	// $cmp =& $GLOBALS['__COMPILER__'];
 	$file_data = strtr($file_data, $GLOBALS['CMP_LOC']);
 
 	if (!$dst) {
@@ -408,6 +408,7 @@
 	$GLOBALS['CURFILE'] = '';
 
 	if (file_exists($file)) {
+	    $m = array();
 		if (preg_match('!thm/([^/]+)/i18n!', $file, $m)) {
 			parse_sections(@file_get_contents($GLOBALS['DATA_DIR'] . 'thm/'.$m[1].'/tmpl/messages'), '');
 		}
@@ -585,7 +586,7 @@
 	}
 	readdir($dp); readdir($dp);
 	while ($de = readdir($dp)) {
-		if (!preg_match($mask, $de, $regs)) {
+		if (!preg_match($mask, $de)) {
 			continue;
 		}
 		$path = $src . '/' . $de;
@@ -593,12 +594,12 @@
 
 		if (@is_dir($path) && $recur == true) {
 			if (!@is_dir($nd) && !@mkdir($nd, 0777)) {
-				exit('can\'t mkdir ('.$nd.')<br>');
+				exit('can\'t mkdir ('.$nd.')<br />');
 			}
 			fudcopy($path, $nd, $mask, true);
 		} else {
 			if (!@copy($path, $nd) && !@file_exists($nd)) {
-				echo 'cannot copy "'.$path.'" to "'.$nd.'"<br>';
+				echo 'cannot copy "'.$path.'" to "'.$nd.'"<br />';
 			} else {
 				@chmod($nd, $GLOBALS['FUD_OPT_2'] & 8388608 ? 0600 : 0666);
 			}
Index: setup/base/include/core.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/core.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 core.inc
--- setup/base/include/core.inc	1 Nov 2003 22:58:45 -0000	1.1.1.1
+++ setup/base/include/core.inc	16 Mar 2004 08:59:00 -0000
@@ -42,8 +42,8 @@
         if (@count($_POST)) {
 		array_walk($_POST, 'strip_quotes');
 	}
-        if (@count($_COOKIES)) {
-		array_walk($_COOKIES, 'strip_quotes');
+        if (@count($_COOKIE)) {
+		array_walk($_COOKIE, 'strip_quotes');
 	}
 	if (@count($_FILES)) {
 		array_walk($_FILES, 'strip_quotes');
Index: setup/base/include/forum_adm.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/forum_adm.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 forum_adm.inc
--- setup/base/include/forum_adm.inc	1 Nov 2003 22:58:44 -0000	1.1.1.1
+++ setup/base/include/forum_adm.inc	16 Mar 2004 08:59:00 -0000
@@ -61,7 +61,7 @@
 			".(int)$this->forum_opt."
 		)");
 
-		if (($gid = group_add($this->id, $this->name, 2))) {
+		if ((group_add($this->id, $this->name, 2))) {
 			grp_rebuild_cache(array(0, 2147483647));
 		}
 
@@ -152,7 +152,7 @@
 		}
 		return 1;
 	}
-	return;
+	return false;
 }
 
 function frm_delete($id)
Index: setup/base/include/glob.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/glob.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 glob.inc
--- setup/base/include/glob.inc	1 Nov 2003 22:58:44 -0000	1.1.1.1
+++ setup/base/include/glob.inc	16 Mar 2004 08:59:00 -0000
@@ -41,7 +41,7 @@
 
 function print_bit_field($descr, $field)
 {
-	$h =& $GLOBALS['help_ar'][$field];
+	//$h =& $GLOBALS['help_ar'][$field];
 	$o =& $h[1];
 
 	echo '<tr bgcolor="#bff8ff"><td>'.$descr.': <br><font size="-1">'.$h[0].'</font></td><td valign="top">';
@@ -80,7 +80,7 @@
 	$settings = file_get_contents($GLOBALS['INCLUDE'] . 'GLOBALS.php');
 	foreach ($list as $k => $v) {
 		if (($p = strpos($settings, '$' . $k)) === false) {
-			$pos = strpos($settings, '$ADMIN_EMAIL');
+			//$pos = strpos($settings, '$ADMIN_EMAIL');
 			if (is_int($v)) {
 				$settings = substr_replace($settings, "\t{$k}\t= {$v};\n", $p, 0);
 			} else {
Index: setup/base/include/groups_adm.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/groups_adm.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 groups_adm.inc
--- setup/base/include/groups_adm.inc	1 Nov 2003 22:58:45 -0000	1.1.1.1
+++ setup/base/include/groups_adm.inc	16 Mar 2004 08:59:00 -0000
@@ -16,7 +16,7 @@
 
 	$gid = db_qid("INSERT INTO ".$tbl."groups (name, inherit_id, groups_opt, groups_opti, forum_id) VALUES
 		('".addslashes($name)."', ".$inherit_id.", ".$perm.", ".$permi.", ".($add_gl == 2 ? $res_id : 0).")");
-	$rid = db_qid("INSERT INTO ".$tbl."group_resources (group_id, resource_id) VALUES (".$gid.", ".$res_id.")");
+	db_qid("INSERT INTO ".$tbl."group_resources (group_id, resource_id) VALUES (".$gid.", ".$res_id.")");
 
 	if ($add_gl) {
 		$reg = q_singleval("SELECT groups_opt FROM ".$tbl."groups WHERE id=2") | 65536;
Index: setup/base/include/mem_limit.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/mem_limit.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 mem_limit.inc
--- setup/base/include/mem_limit.inc	1 Nov 2003 22:58:45 -0000	1.1.1.1
+++ setup/base/include/mem_limit.inc	16 Mar 2004 08:59:00 -0000
@@ -28,8 +28,9 @@
 
 function mem_limit_to_int($str)
 {
+    $m = array();
 	if (!preg_match('!([0-9]+)([GMKgmk]+)?!', $str, $m)) {
-		return;
+		return false;
 	}
 	$lmt = $m[1];
 	if (isset($m[2])) {
Index: setup/base/include/nntp.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/nntp.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 nntp.inc
--- setup/base/include/nntp.inc	1 Nov 2003 22:58:46 -0000	1.1.1.1
+++ setup/base/include/nntp.inc	16 Mar 2004 08:59:00 -0000
@@ -44,7 +44,6 @@
 			switch ($this->cmd('AUTHINFO user '.$this->user, false)) {
 				case 281:
 					return true;
-					break 2;
 				case 381:
 					if ($this->cmd('AUTHINFO pass '.$this->pass, false) != 281) {
 						$this->error = "Authentication failed\n";
@@ -52,10 +51,8 @@
 					} else {
 						return true;
 					}
-					break;
 				default:
 					return false;
-					break;
 			}
 		} else if (!($this->nntp_opt & 64)) {
 			if ($this->cmd('AUTHINFO SIMPLE', false) != 350) {
@@ -91,6 +88,8 @@
 
 	function connect()
 	{
+	    $errno = 0;
+	    $errstr = '';
 		$this->fs = @fsockopen($this->server, $this->port, $errno, $errstr, $this->timeout);
 		if (!@is_resource($this->fs)) {
 			$this->error = "Unable to establish connection to $this->server on port $this->port failed\nWith Error #$errno : $errstr\n";
@@ -145,6 +144,7 @@
 			$this->raw_msg .= $line;
 		}
 
+		$m = array();
 		if (!preg_match("!^(.*?)\r?\n\r?\n(.*)!s", $this->raw_msg, $m)) {
 			return false;
 		}
@@ -186,6 +186,7 @@
 		}
 
 		// This fetches the id of the message if this is a reply to an existing message
+		$match = array();
 		if (!empty($this->headers['references']) && preg_match_all('!<?([^\s<>]+)>?!', trim($this->headers['references']), $match)) {
 			$this->reply_to_msg_id = array_reverse($match[1]);
 		} else if (!empty($this->headers['reply-to']) && preg_match('!.*<?([^>]+)>?$!', trim($this->headers['reply-to']), $match)) {
@@ -193,6 +194,7 @@
 		}
 
 		// Fetch From email and Possible name
+		$matches = array();
 		if (preg_match('!(.*?)<(.*?)>!', $this->headers['from'], $matches)) {
 			$this->from_email = trim($matches[2]);
 
@@ -371,6 +373,7 @@
 			$msg_post = new fud_msg_edit;
 
 			// Handler for our own messages, which do not need to be imported.
+			$m = array();
 			if (isset($this->headers['x-fudforum']) && preg_match('!([A-Za-z0-9]{32}) <([0-9]+)>!', $this->headers['x-fudforum'], $m)) {
 				if ($m[1] == md5($GLOBALS['WWW_ROOT'])) {
 					q("UPDATE ".sql_p."msg SET mlist_msg_id='".addslashes($this->msg_id)."' WHERE id=".intval($m[2])." AND mlist_msg_id IS NULL");
@@ -411,7 +414,7 @@
 			// Handle File Attachments
 			if (isset($this->attachments) && is_array($this->attachments)) {
 				foreach($this->attachments as $key => $val) {
-					if (!($nntp_adm->nntp_opt & 8) && (strlen($val) > $frm->max_attach_size || (isset($attach_list) && count($attach_list) > $frm->max_file_attachments) || filter_ext($key))) {
+					if (!($nntp_adm->nntp_opt & 8) && ((strlen($val) > $frm->max_attach_size) || (isset($attach_list) && (count($attach_list) > $frm->max_file_attachments)) || filter_ext($key))) {
 						continue;
 					}
 
@@ -454,7 +457,7 @@
 	function read_start()
 	{
 		if (!@file_exists($GLOBALS['ERROR_PATH'].'.nntp/'.$this->server.'-'.$this->newsgroup)) {
-			return;
+			return false;
 		}
 
 		return (int) trim(file_get_contents($GLOBALS['ERROR_PATH'].'.nntp/'.$this->server.'-'.$this->newsgroup));
Index: setup/base/include/scripts_common.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/scripts_common.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 scripts_common.inc
--- setup/base/include/scripts_common.inc	1 Nov 2003 22:58:46 -0000	1.1.1.1
+++ setup/base/include/scripts_common.inc	16 Mar 2004 08:59:00 -0000
@@ -42,6 +42,7 @@
 	}
 	if (empty($r) && $complex) {
 		// This is slow, but only way to match 'rouge' replies in the event no reference fields are avaliable
+        $matches = array();
 		if (preg_match('!(Re|Wa)\s*:(.*)$!i', $subject, $matches)) {
 			$r = db_saq('SELECT m.id, m.thread_id FROM '.sql_p.'msg m INNER JOIN '.sql_p.'thread t ON m.thread_id=t.id WHERE t.forum_id='.$forum_id.' AND m.subject='.strnull(addslashes(trim($matches[2]))));
 		}
@@ -52,10 +53,11 @@
 
 function parse_ip($str)
 {
+    $m = array();
 	if (preg_match('!([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})!', $str, $m)) {
 		return $m[1];
 	} else {
-		return;
+		return false;
 	}
 }
 
@@ -65,13 +67,10 @@
 		case 'quoted-printable':
 			// Remove soft line breaks & decode
 		        return quoted_printable_decode(preg_replace("!=\r?\n!", '', $str));
-			break;
 		case 'base64':
 			return base64_decode($str);
-			break;
 		default:
 			return $str;
-			break;
 	}
 }
 
@@ -83,6 +82,7 @@
 	}
 
 	// Decode String
+	$m = array();
 	if (preg_match_all('!(.*?)(=\?([^?]+)\?(Q|B)\?([^?]*)\?=)[[:space:]]*(.*)!i', $val, $m)) {
 		$newval = '';
 
Index: setup/base/include/widgets.inc
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/include/widgets.inc,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 widgets.inc
--- setup/base/include/widgets.inc	1 Nov 2003 22:58:44 -0000	1.1.1.1
+++ setup/base/include/widgets.inc	16 Mar 2004 08:59:00 -0000
@@ -13,7 +13,7 @@
 
 function create_select($name, $options, $opt_val, $def_val, $js='', $extraval='')
 {
-	if( !strlen($options) ) return;
+	if( !strlen($options) ) return false;
 
 	$options = str_replace("\t", "", $options);
 	$opt_val = str_replace("\t", "", $opt_val);
Index: setup/base/scripts/maillist.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/scripts/maillist.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 maillist.php
--- setup/base/scripts/maillist.php	1 Nov 2003 22:58:36 -0000	1.1.1.1
+++ setup/base/scripts/maillist.php	16 Mar 2004 08:59:00 -0000
@@ -29,6 +29,7 @@
 
 	function split_hdr_body()
 	{
+	    $m = array();
 		if (!preg_match("!^(.*?)\r?\n\r?\n(.*)!s", $this->raw_msg, $m)) {
 			return;
 		}
@@ -67,6 +68,7 @@
 		if (($p = strpos($val, ';')) !== false) {
 			$this->headers[$key] = strtolower(trim(substr($val, 0, $p)));
 			$val = ltrim(substr($val, $p+1));
+			$m = array();
 			if (!empty($val) && preg_match_all('!([-A-Za-z]+)="?(.*?)"?\s*(;|$)!', $val, $m)) {
 				$c = count($m[0]);
 				for ($i=0; $i<$c; $i++) {
@@ -242,6 +244,7 @@
 		}
 
 		// Fetch From email and Possible name
+		$matches = array();
 		if (preg_match('!(.*?)<(.*?)>!', $this->headers['from'], $matches)) {
 			$this->from_email = trim($matches[2]);
 
@@ -275,6 +278,7 @@
 		}
 
 		// This fetches the id of the message if this is a reply to an existing message
+		$match = array();
 		if (!empty($this->headers['in-reply-to']) && preg_match('!.*<([^>]+)>$!', trim($this->headers['in-reply-to']), $match)) {
 			$this->reply_to_msg_id = $match[1];
 		} else if (!empty($this->headers['references']) && preg_match('!.*<([^>]+)>!', trim($this->headers['references']), $match)) {
@@ -392,6 +396,7 @@
 	$msg_post = new fud_msg_edit;
 
 	// Handler for our own messages, which do not need to be imported.
+	$m = array();
 	if (isset($emsg->headers['x-fudforum']) && preg_match('!([A-Za-z0-9]{32}) <([0-9]+)>!', $emsg->headers['x-fudforum'], $m)) {
 		if ($m[1] == md5($GLOBALS['WWW_ROOT'])) {
 			q("UPDATE ".sql_p."msg SET mlist_msg_id='".addslashes($emsg->msg_id)."' WHERE id=".intval($m[2])." AND mlist_msg_id IS NULL");
Index: setup/base/www_root/adm/admbrowse.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admbrowse.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admbrowse.php
--- setup/base/www_root/adm/admbrowse.php	1 Nov 2003 22:58:38 -0000	1.1.1.1
+++ setup/base/www_root/adm/admbrowse.php	16 Mar 2004 08:59:02 -0000
@@ -75,17 +75,17 @@
 function fud_rmdir($dir)
 {
 	if (!($d = opendir($dir))) {
-		return;
+		return false;
 	}
 	readdir($d); readdir($d);
 	while ($f = readdir($d)) {
 		if (@is_dir($dir . '/' . $f)) {
 			if (!fud_rmdir($dir . '/' . $f)) {
-				return;
+				return false;
 			}
 		} else {
 			if (!@unlink($dir . '/' . $f)) {
-				return;
+				return false;
 			}
 		}
 	}
Index: setup/base/www_root/adm/admcat.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admcat.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admcat.php
--- setup/base/www_root/adm/admcat.php	1 Nov 2003 22:58:39 -0000	1.1.1.1
+++ setup/base/www_root/adm/admcat.php	16 Mar 2004 08:59:02 -0000
@@ -10,6 +10,8 @@
 * (at your option) any later version.
 ***************************************************************************/
 
+// $cat_description,$cat_name are undefined - incoming from FORM
+
 	require('./GLOBALS.php'); fud_phpgw();
 
 	fud_use('adm.inc', true);
Index: setup/base/www_root/adm/admforum.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admforum.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admforum.php
--- setup/base/www_root/adm/admforum.php	1 Nov 2003 22:58:40 -0000	1.1.1.1
+++ setup/base/www_root/adm/admforum.php	16 Mar 2004 08:59:02 -0000
@@ -10,6 +10,8 @@
 * (at your option) any later version.
 ***************************************************************************/
 
+// $frm_name, $frm_descr, $frm_post_passwds, $frm_forum_icon is undefined; incoming from FORM
+
 function get_max_upload_size()
 {
 	$us = strtolower(ini_get('upload_max_filesize'));
Index: setup/base/www_root/adm/admglobal.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admglobal.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admglobal.php
--- setup/base/www_root/adm/admglobal.php	1 Nov 2003 22:58:40 -0000	1.1.1.1
+++ setup/base/www_root/adm/admglobal.php	16 Mar 2004 08:59:02 -0000
@@ -224,7 +224,7 @@
 	print_reg_field('Flood Trigger (seconds)', 'FLOOD_CHECK_TIME', 1);
 	print_reg_field('Moved Topic Pointer Expiry', 'MOVED_THR_PTR_EXPIRY', 1);
 ?>
-<tr bgcolor="#bff8ff"><td colspan=2>Server Time Zone: <font size="-1"> <?php echo $help_ar['SERVER_TZ'][0]; ?></font><br /><select name="CF_SERVER_TZ" style="font-size: xx-small;"><?php echo tmpl_draw_select_opt($tz_values, $tz_names, $SERVER_TZ, '', ''); ?></select></td></tr>
+<tr bgcolor="#bff8ff"><td colspan=2>Server Time Zone: <font size="-1"> <?php echo $help_ar['SERVER_TZ'][0]; ?></font><br /><select name="CF_SERVER_TZ" style="font-size: xx-small;"><?php echo tmpl_draw_select_opt($tz_values, $tz_names, $SERVER_TZ, '', ''); /* $tz_values,$tz_names are undefined */ ?></select></td></tr>
 <?php
 	print_bit_field('Forum Search Engine', 'FORUM_SEARCH');
 	print_reg_field('Search results cache', 'SEARCH_CACHE_EXPIRY', 1);
Index: setup/base/www_root/adm/admmassemail.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admmassemail.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admmassemail.php
--- setup/base/www_root/adm/admmassemail.php	1 Nov 2003 22:58:37 -0000	1.1.1.1
+++ setup/base/www_root/adm/admmassemail.php	16 Mar 2004 08:59:02 -0000
@@ -26,13 +26,13 @@
 
 	if (!empty($_POST['subject']) && !empty($_POST['body'])) {
 		if (!$_POST['group']) {
-			$c = uq('SELECT email FROM '.$DBHOST_TBL_PREFIX.'users '.(isset($POST['ignore_override']) ? '' : 'WHERE (users_opt & 8)=0'));
+			$c = uq('SELECT email FROM '.$DBHOST_TBL_PREFIX.'users '.(isset($_POST['ignore_override']) ? '' : 'WHERE (users_opt & 8)=0'));
 		} else if (!isset($groups[$_POST['group']])) {
 			echo '<font color="+1" color="red">Invalid group id</font><br />';
 			$err = 1;
 			$c = uq('SELECT id FROM '.$DBHOST_TBL_PREFIX.'users WHERE id=-1');
 		} else {
-			$c = uq('SELECT email FROM '.$DBHOST_TBL_PREFIX.'group_members gm INNER JOIN '.$DBHOST_TBL_PREFIX.'users u ON u.id=gm.user_id WHERE gm.group_id='.$_POST['group'].(isset($POST['ignore_override']) ? '' : ' AND (users_opt & 8)=0'));
+			$c = uq('SELECT email FROM '.$DBHOST_TBL_PREFIX.'group_members gm INNER JOIN '.$DBHOST_TBL_PREFIX.'users u ON u.id=gm.user_id WHERE gm.group_id='.$_POST['group'].(isset($_POST['ignore_override']) ? '' : ' AND (users_opt & 8)=0'));
 		}
 
 		$email_block = 50;
Index: setup/base/www_root/adm/admmlist.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admmlist.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admmlist.php
--- setup/base/www_root/adm/admmlist.php	1 Nov 2003 22:58:40 -0000	1.1.1.1
+++ setup/base/www_root/adm/admmlist.php	16 Mar 2004 08:59:02 -0000
@@ -10,10 +10,12 @@
 * (at your option) any later version.
 ***************************************************************************/
 
+// $ml_name,$ml_forum_id,$ml_mlist_opt,$ml_subject_regex_needle,$ml_body_regex_needle,$ml_additional_headers are undefined; incoming from FORM
+
 function format_regex(&$regex)
 {
 	if (empty($regex)) {
-		return;
+		return false;
 	}
 
 	$s = strpos($regex, '/') + 1;
Index: setup/base/www_root/adm/admnntp.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admnntp.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admnntp.php
--- setup/base/www_root/adm/admnntp.php	1 Nov 2003 22:58:39 -0000	1.1.1.1
+++ setup/base/www_root/adm/admnntp.php	16 Mar 2004 08:59:02 -0000
@@ -10,6 +10,8 @@
 * (at your option) any later version.
 ***************************************************************************/
 
+// $nntp_server,$nntp_port,$nntp_timeout,$nntp_newsgroup,$nntp_nntp_opt,$nntp_login,$nntp_pass,$nntp_forum_id are undefined; incoming from FORM
+
 	require('./GLOBALS.php'); fud_phpgw();
 	fud_use('adm.inc', true);
 	fud_use('widgets.inc', true);
Index: setup/base/www_root/adm/admspell.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admspell.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admspell.php
--- setup/base/www_root/adm/admspell.php	1 Nov 2003 22:58:37 -0000	1.1.1.1
+++ setup/base/www_root/adm/admspell.php	16 Mar 2004 08:59:02 -0000
@@ -22,7 +22,7 @@
 	if (!empty($_POST['words'])) {
 		$wl = explode("\n", trim($_POST['words']));
 		if (count($wl)) {
-			$pspell_config = pspell_config_create($usr->pspell_lang);
+			$pspell_config = pspell_config_create($usr->pspell_lang); // $usr possible udefined
 			pspell_config_personal($pspell_config, $FORUM_SETTINGS_PATH."forum.pws");
 			$pspell_link = pspell_new_config($pspell_config);
 
Index: setup/base/www_root/adm/admstats.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admstats.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admstats.php
--- setup/base/www_root/adm/admstats.php	1 Nov 2003 22:58:41 -0000	1.1.1.1
+++ setup/base/www_root/adm/admstats.php	16 Mar 2004 08:59:02 -0000
@@ -21,7 +21,7 @@
 	$disk_space = 0;
 
 	if (!($dir = @opendir($dirp))) {
-		return;
+		return false;
 	}
 	readdir($dir); readdir($dir);
 
@@ -44,7 +44,7 @@
 {
 	$ver = q_singleval('SELECT VERSION()');
 	if ($ver[0] != 4 && strncmp($ver, '3.23', 4)) {
-		return;
+		return false;
 	}
 
 	$sql_size = 0;
Index: setup/base/www_root/adm/admthemes.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admthemes.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admthemes.php
--- setup/base/www_root/adm/admthemes.php	1 Nov 2003 22:58:39 -0000	1.1.1.1
+++ setup/base/www_root/adm/admthemes.php	16 Mar 2004 08:59:02 -0000
@@ -10,6 +10,8 @@
 * (at your option) any later version.
 ***************************************************************************/
 
+// $thm_name,$thm_theme,$thm_lang are undefined; incoming from FORM
+
 function get_func_usage(&$toks)
 {
 	foreach ($toks as $k => $tok) {
Index: setup/base/www_root/adm/admuser.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/admuser.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 admuser.php
--- setup/base/www_root/adm/admuser.php	1 Nov 2003 22:58:38 -0000	1.1.1.1
+++ setup/base/www_root/adm/admuser.php	16 Mar 2004 08:59:02 -0000
@@ -43,7 +43,7 @@
 			}
 
 			if (isset($_GET['f'])) {
-				header('Location: '.$WWW_ROOT.__fud_index_name__.$usr->returnto);
+				header('Location: '.$WWW_ROOT.__fud_index_name__.$usr->returnto); // $usr possible undefined
 				exit;
 			}
 			break;
Index: setup/base/www_root/adm/consist.php
===================================================================
RCS file: /cvsroot/phpgroupware/fudforum/setup/base/www_root/adm/consist.php,v
retrieving revision 1.1.1.1
diff -u -r1.1.1.1 consist.php
--- setup/base/www_root/adm/consist.php	1 Nov 2003 22:58:39 -0000	1.1.1.1
+++ setup/base/www_root/adm/consist.php	16 Mar 2004 08:59:02 -0000
@@ -133,7 +133,7 @@
 	$c = q('SELECT id, view_order FROM '.$tbl.'cat ORDER BY view_order, id');
 	while ($r = db_rowarr($c)) {
 		if ($r[1] != $i) {
-			q('UPDATE '.$tbl.'cat SET view_order='.$i.' WHERE id='.$id);
+			q('UPDATE '.$tbl.'cat SET view_order='.$i.' WHERE id='.$r[0]);
 		}
 		++$i;
 	}